function [w_opt_port, D_opt_port] = get_opt_port(ER, VR, Eport)
% n ---   ;
n = length(ER);
% w0 ---     ; 
%     w0 = [1/n, ..., 1/n]';
w0 = (1/n) * ones(n,1);
%__________________________________________________________________________
%     fmincon:
% fun ---  ,       , 
%     ;
%    get_port_var(w, VR)   w (-  (nx1));
%    ,      w,  
%     @  w;
fun = @(w) get_port_var(w, VR);
% x0 ---     ; 
x0 = w0;
% c   A  b     Ax<=b;
%      ;
%    A = []; b = [];
A = [];
b = [];
% c   Aeq  beq     Aeq x = beq;
%    Aeq     [1, 1, ..., 1]  ER', 
%  beq      1  Eport;
Aeq = [ones(1,n); ER'];
beq = [1; Eport];
% c   lb (lower bound ---  )  
% ub (upper bound ---  )     lb <= x <= ub;
%    lb = [0, 0, ..., 0]'  ub = [1, 1, ..., 1]'; 
lb = zeros(n,1);
ub = ones(n,1);
%   nonlcon   ,    ;
%  nonlcon = [];
nonlcon = [];
%   options    ;
options = optimset('Algorithm', 'interior-point', 'Display', 'off');
%__________________________________________________________________________
%       fmincon.
[w_opt_port, D_opt_port] = fmincon(fun,x0,A,b,Aeq,beq,lb,ub,nonlcon,options);
%__________________________________________________________________________


%  ,    :
function [D] = get_port_var(w, VR)
D = w' * VR * w;